
#' friendlyts
#' @param path path
#' @param url url
#' @param df df
#' @param date_col date_col
#' @param varnames varnames
#' @param date_type date_type
#' @param fromDate from "2016/11/01 00:00:00"
#' @param toDate to "2017/05/01 00:00:00"
#' @param timeResolution "daily","hourly","minute","second",...
#' @param v multiplicative coefficient to the timeResolution
#' @param precision "daily","hourly","minute","second",...
#' @param tzone time zone "UTC"
#' @param CHECKNAS boolean take out columns with NAs only
#' @keywords friendlyts
#' @export
#' @examples
#' \dontrun{
#' friendlyts()
#' }
friendlyts <- function(path=NULL,url=NULL,df=NULL,date_col=NULL,varnames=NULL,date_type=c("posixlt","df_yymmdd_hhmmss","%Y-%m-%d %H:%M:%S","%Y-%m-%dT%H:%M:%OSZ","%Y/%m/%d %H:%M:%S"),fromDate=NULL,toDate=NULL,timeResolution=NULL,v=1,precision=NULL,tzone="UTC",CHECKNAS=TRUE){

  if ( (!is.null(path) || !is.null(url)) && (!is.null(date_type)) ) {

    df <- import_(path=path,url=url)
    res <- as_tbl_friendlyts(df=df,precision=precision,date_col=date_col,date_type=date_type,tzone=tzone,CHECKNAS=CHECKNAS)

  } else if ( (!is.null(df)) && (!is.null(date_type)) ) {

    res <- as_tbl_friendlyts(df=df,precision=precision,date_col=date_col,date_type=date_type,tzone=tzone,CHECKNAS=CHECKNAS)

  } else if (!is.null(varnames) && !is.null(fromDate) && !is.null(toDate) && (!is.null(date_type)) ){

    res <- new_tbl_friendlyts(fromDate=fromDate,toDate=toDate,timeResolution=timeResolution,v=v,precision=precision,tzone=tzone,varnames=varnames,date_type=date_type)

  } else stop("Need either path, url, df, or varnames, fromDate and toDate")

  return(res)

}
