
export_ <-function(df,name,format){
  filename <- file_friendlyts(name,format)
  switch(format,
     "json" = export_json(df=df,filename=filename),
     "csv"  = export_csv(df=df,filename=filename),
     "rda"  = export_rda(df=df,filename=filename),
     stop("format not recognized: ", format))
  return(filename)
}

export_json <- function(df, filename){
  if (!is.null(filename)) {
    write(jsonlite::toJSON(df),filename)
    return(filename)
  } else return(jsonlite::toJSON(df))
}

export_rda <- function(df, filename){
  if (!is.null(filename)) {
    save(df,file=filename)
    return(filename)
  } else return(df)
}

export_csv <- function(df, filename){
  if (!is.null(filename)) {
    utils::write.csv(df,filename)
    return(filename)
  } else return(df)
}

import_ <- function(path=NULL,url=NULL){
  if (!is.null(path) && is.null(url) ) {
    target <- paste0("file://",path)
  } else if (is.null(path) && !is.null(url) ) {
    target <- url
  } else stop("Both path and url are non-NULL")
  return(import_target(target))
}

import_target <- function(target){
  ext <- tools::file_ext(target)
  res <- switch(ext,
    "rda"  = get_rda(curl::curl(target)),
    "json" = jsonlite::fromJSON(curl::curl(target)),
    "csv"  = utils::read.csv(curl::curl(target),header=TRUE),
    stop("extension not recognized: ", ext))
  return(res)
}

get_rda <- function(target){
  env <- environment()
  load(target, envir = env, verbose = FALSE)
  return(get("df",envir=env))
}
